---
--- Generated by EmmyLua(https://github.com/EmmyLua)
--- Created by brode.
--- DateTime: 11.06.2021 16:10
---


local AddonName, BohemkaDKP = ...

BohemkaDKP.frames = {}
BohemkaDKP.roster = {}
BohemkaDKP.rosterIndex = {}
BohemkaDKP.sortedRoster = {}
BohemkaDKP.guildRoster = {}
BohemkaDKP.bidInfo = {}
BohemkaDKP.bidHistory = {}
BohemkaDKP.editModeSelected = {}
BohemkaDKP.passedHistory = {}
BohemkaDKP.suspects = {}
BohemkaDKP.conflicts = {}
BohemkaDKP.onlineChecks = {}
BohemkaDKP.currentItem = nil


function BohemkaDKP:OnLoad()
    self:CheckCompatibility()
    self:UpdateCompatibility()
    self:HookScripts()
    self:HookLootFrame()
    C_GuildInfo.GuildRoster();
    self:LoadUI()
    self.onlineSince = GetServerTime()
end
function BohemkaDKP:LoadDataWhenReady()
    if GetNumGuildMembers() == 0 then
        C_Timer.After(1, function ()
            BohemkaDKP:LoadDataWhenReady()
        end)
    else
        self.firstLoad = false
        self:CacheGuildRoster()
        self:RequestProfessionInfo()
        self:RequestTalentsInfo()
        C_Timer.After(300, function ()
            self:CheckAutoBackup()
        end)
        self:InitialSync()
        self:SaveCharacterInfo()
    end
end
function BohemkaDKP:LoadUI()
    self:AddStaticPopups()
    self:CreateInterfaceConfig()
    self:CreateAuctionFrame()
    self:AdjustUI()
end
function BohemkaDKP:OnUpdateCompatibilityCallback() end
function BohemkaDKP:OnUiAdjustedCompatibilityCallback() end
function BohemkaDKP:CheckCompatibility()
    name, title, notes, loadable, reason, security, newVersion = GetAddOnInfo("ElvUI")
    self.isElvUI = loadable
end
function BohemkaDKP:GetCurrentGuildButtonFrameNamePrefix()
    if FriendsFrame.playerStatusFrame then
        return "GuildFrameButton"
    else
        return "GuildFrameGuildStatusButton"
    end
end

function BohemkaDKP:CacheGuildRoster()
    local newRoster = {}
    local newRosterIndex = {}
    local newRosterDKP= {}
    local n = 0
    local totalMembers, _, _ = GetNumGuildMembers();
    local canEdit = CanEditPublicNote()
    local canEditOfficer = CanEditOfficerNote()
    for i = 0, totalMembers do
        fullName, rank, rankIndex, level, class, zone, note, officernote, online, isAway, classFileName = GetGuildRosterInfo(i);
        if fullName then
            newRoster[fullName] = { fullName, rank, rankIndex, level, class, zone, note, officernote, online, isAway, classFileName }
            newRosterIndex[fullName] = i
            local currentDKP = self:NoteDKPToNumber(note)
            if self.roster[fullName] ~= currentDKP then
                self.suspects[fullName] = currentDKP
            end
            if currentDKP == nil and canEdit then
                currentDKP = BohemkaDKPConfig.startingDKP
                if canEditOfficer and note ~= nil and note ~= "" then
                    GuildRosterSetOfficerNote(i, note)
                end
                self:SaveDKP(i, currentDKP, nil, "Initial DKP")
            end
            newRosterDKP[fullName] = currentDKP
            n = n + 1
        end
    end
    self.guildRoster = newRoster
    self.rosterIndex = newRosterIndex
    self.roster = newRosterDKP

    C_Timer.After(5, function ()
        for name, dkp in pairs(BohemkaDKP.suspects) do
            BohemkaDKP:DetectChanges(name, dkp)
            BohemkaDKP.suspects[name] = nil
        end
    end)
end


function BohemkaDKP:SendEvent(channel, event, ...)
    BohemkaDKP:Debug(event, "Processing payload for event", ...)
    local payload = self:PreparePayload(event, ...)
    if not payload then
        return
    end
    BohemkaDKP:Debug(event, "Sending event", channel, payload)
    self:SendAddonMessage(payload, channel)
end

function BohemkaDKP:SendEventTo(target, event, ...)
    BohemkaDKP:Debug(event, "Processing payload for event", ...)
    local payload = self:PreparePayload(event, ...)
    if not payload then
        return
    end
    BohemkaDKP:Debug(event, "Sending event to", target, payload)
    self:SendAddonMessage(payload, "WHISPER", target)

end
function BohemkaDKP:SendAddonMessage(payload, ...)
    local cps = #payload + self.cpsOverhead
    if cps > BohemkaDKP:GetCPSLimit() then
        table.insert(self.cpsQueue, {payload, ...})
        return
    end
    self.cps = self.cps + cps
    C_ChatInfo.SendAddonMessage(AddonName, payload, ...)
end
function BohemkaDKP:PreparePayload(event, ...)
    local data = {...}
    if BohemkaDKPConfig.debug then
        for _, v in ipairs(data) do
            if v == nil or type(v) == "boolean" then
                self:Print("Wrong data to send", event, v)
                return
            end
        end
    end
    local payload = table.concat(data, self.EVENT_SEPARATOR)
    if #payload > 0 then
        payload = event..self.EVENT_SEPARATOR..payload
    else
        payload = event
    end
    return payload
end


function BohemkaDKP:AddClassColorToName(name)
    local shortName = strsplit("-", name)
    if self.guildRoster[name] then
        local _, _, _, _, _, _, _, _, _, _, classFileName2  = unpack(self.guildRoster[name])
        classFileName = classFileName2
    else
        local _, classFileName2, _ = UnitClass(shortName)
        classFileName = classFileName2
    end
    if classFileName then
        local color = RAID_CLASS_COLORS[classFileName]
        local escapeColor = format("|cff%02x%02x%02x", color.r*255, color.g*255, color.b*255)
        shortName = escapeColor..shortName.."|r"
    end
    return shortName
end

function BohemkaDKP:GetBroadcastChannel()
    if IsInRaid() then
        return "RAID"
    end
    if IsInGroup() then
        return "PARTY"
    end
    return "GUILD"
end
function BohemkaDKP:ChatBid(msg, sender)
    local number = tonumber(msg)
    if BohemkaDKP.currentItem and number then
        number = number - BohemkaDKP.currentItem.price
        BohemkaDKP:OnBidRequest(number, BohemkaDKP.currentItem.auctionId, sender)
    elseif msg == "pass" then
        BohemkaDKP:Pass()
    end
end
function BohemkaDKP:OnOnlineCheck(sender)
    self:SendEventTo(sender, self.EVENT.ONLINE_CHECK_RESPONSE, self.onlineSince, BohemkaDKPConfig.lastTimeOnline)
end

function BohemkaDKP:OnOnlineCheckResponse(time, lastTimeOnline, sender)
    table.insert(self.onlineChecks, { onlineSince = tonumber(time), lastTimeOnline = tonumber(lastTimeOnline), name = sender})
end
function BohemkaDKP:InitialSync()
    self:SendEvent("GUILD", self.EVENT.ONLINE_CHECK)
    C_Timer.After(10, function ()
        if #self.onlineChecks == 0 then
            return
        end
        table.sort(self.onlineChecks, function (a, b) return a.onlineSince < b.onlineSince end)
        local mainSource = false
        for _, member in ipairs(self.onlineChecks) do
            if not mainSource and self.onlineSince - member.onlineSince > 300 then
                self:Debug("Syncing log from", member)
                self:SyncLogFrom(member.name)
                mainSource = true
            elseif self.onlineSince - member.onlineSince <= 300 then
                self:Debug("Syncing log from", member)
                self:SyncLogFrom(member.name)
            end
        end
        table.sort(self.onlineChecks, function (a, b) return a.lastTimeOnline < b.lastTimeOnline end)
        self:LogToChunks(self.onlineChecks[1].lastTimeOnline, function(id, size)
            BohemkaDKP:SendEvent("GUILD", BohemkaDKP.EVENT.PAYLOAD_START, size, id)
        end)
    end)
end
