---
--- Generated by EmmyLua(https://github.com/EmmyLua)
--- Created by brode.
--- DateTime: 11.06.2021 16:14
---

local _, BohemkaDKP = ...

function GuildStatus_UpdateHook()
    local members = GetNumGuildMembers()
    if members > 0 then
        BohemkaDKP:CacheGuildRoster()
        BohemkaDKP:RefreshTotalDKP()
        BohemkaDKP:UpdateBidButtonState()
        BohemkaDKP:GuildStatusUpdateUI()
    end
end

function BohemkaDKP:GuildStatusUpdateUI()
    self:AdjustGuildFramesAfterUpdate()
    self:UpdateDetailFrame()
    self:UpdateUIGuildPermissions()
    self:UpdateAuctionUIState()
end

hooksecurefunc("GuildStatus_Update", GuildStatus_UpdateHook)

function BohemkaDKP:HookScripts()
    local defaultWidth = FriendsFrame:GetWidth()
    GuildFrame:HookScript("OnShow", function()
        FriendsFrame:SetWidth(BohemkaDKP:GetFriendsFrameWidth())
    end)

    for i = 1, FRIENDS_FRAME_TAB_COUNT do
        button = getglobal("FriendsFrameTab"..i);
        button:HookScript("OnClick", function(...)
            local tabIndex = PanelTemplates_GetSelectedTab(FriendsFrame)
            if tabIndex ~= 3 then
                FriendsFrame:SetWidth(defaultWidth)
            end
        end)
    end
end


function BohemkaDKP:HookLootFrame()
    if self.isElvUI then
        local fn = ElvUI[1].Bags.ConstructContainerButton
        ElvUI[1].Bags.ConstructContainerButton = function(...)
            local frame = fn(...)
            BohemkaDKP:HookContainerItemFrame(frame)
            return frame
        end

    end

    for i = 1, 4 do
        BohemkaDKP:HookLootItemFrame(_G["LootButton"..i], i)
    end
    for i = 1, 11 do
        local n = 1
        while true do
            local itemFrame = getglobal("ContainerFrame"..i.."Item"..n)
            if not itemFrame then
                break
            end
            BohemkaDKP:HookContainerItemFrame(itemFrame)
            n = n + 1
        end

    end
end

function BohemkaDKP:HookLootItemFrame(frame, index)
    frame:HookScript("OnClick", function()

        if (IsAltKeyDown()) then
            local numLootItems = GetNumLootItems()
            local numLootToShow = LOOTFRAME_NUMBUTTONS;
            if ( numLootItems > LOOTFRAME_NUMBUTTONS ) then
                numLootToShow = numLootToShow - 1; -- make space for the page buttons
            end
            local slot = (numLootToShow * (LootFrame.page - 1)) + index;
            local texture, item, quantity, currencyID, quality, _, _, _, _ = GetLootSlotInfo(slot);
            if ( currencyID ) then
                item, texture, quantity, quality = CurrencyContainerUtil.GetCurrencyContainerInfo(currencyID, quantity, item, texture, quality);
            end

            local itemLink = GetLootSlotLink(slot)
            BohemkaDKP:StartAuction(itemLink, quantity, frame)

        end
    end)
end

function BohemkaDKP:HookLootItemFrameElvUI(frame, index)
    frame:HookScript("OnClick", function()
        if (IsAltKeyDown()) then
            local texture, item, quantity, currencyID, quality, _, _, _, _ = GetLootSlotInfo(index);
            if ( currencyID ) then
                item, texture, quantity, quality = CurrencyContainerUtil.GetCurrencyContainerInfo(currencyID, quantity, item, texture, quality);
            end

            local itemLink = GetLootSlotLink(index)
            BohemkaDKP:StartAuction(itemLink, quantity, frame.iconFrame)
        end
    end)
end


function BohemkaDKP:HookContainerItemFrame(frame)
    frame:HookScript("OnClick", function(self)
        if (IsAltKeyDown()) then
            texture, itemCount, locked, quality, readable, lootable, itemLink = GetContainerItemInfo(self:GetParent():GetID(), self:GetID());
            BohemkaDKP:StartAuction(itemLink, itemCount, frame)
        end
    end)
end
