---
--- Generated by EmmyLua(https://github.com/EmmyLua)
--- Created by brode.
--- DateTime: 11.06.2021 16:12
---

local AddonName, BohemkaDKP = ...
local LibDeflate = LibStub:GetLibrary("LibDeflate")
local LibSerialize = LibStub("LibSerialize")

BohemkaDKPConfig = {
    timerColors = {
        { 60, {r = 0, g = 0.6, b = 0.1}},
        { 40, {r = 0.9, g = 0.7, b = 0}},
        { 20, {r = 0.75, g = 0.27, b = 0}},
        { 0, {r = 0.8, g = 0.3, b = 0.22}},
    },
    timerMax = 10,
    minItemPrice = 20,
    channel = "RAID",
    bidCooldown = 1,
    minBid = 10,
    startingDKP = 100,
    bossRewards = {},
    itemPrices = {},
    debug = false,
    showDKP = true,
    showProfessions = true,
    autoBackup = 24,
}
DKPLog = {
    current = BohemkaDKP:InitDKPLog(),
    backup = {}
}
RosterData = {
    professions = {},
    talents = {},
}
AccountData = {
    characters = {}
}

BohemkaDKP.currentTime = BohemkaDKPConfig.timerMax
BohemkaDKP.lastShareTime = 0
BohemkaDKP.chunks = {}
BohemkaDKP.chunksToSend = {}

BohemkaDKP.REQUIRED_ADDONS = {
    [AddonName] = false,
}

BohemkaDKP.UNCOMPATIBLE_ADDONS = {
}


local EventFrame = CreateFrame('Frame')
EventFrame:RegisterEvent('ADDON_LOADED')
EventFrame:RegisterEvent('GUILD_ROSTER_UPDATE')
EventFrame:RegisterEvent('CHAT_MSG_ADDON')
EventFrame:RegisterEvent('GET_ITEM_INFO_RECEIVED')
EventFrame:RegisterEvent('CHAT_MSG_SKILL')
EventFrame:RegisterEvent('CHAT_MSG_RAID')
EventFrame:RegisterEvent('CHAT_MSG_GUILD')
EventFrame:RegisterEvent('CHAT_MSG_PARTY')
EventFrame:RegisterEvent('CHAT_MSG_PARTY_LEADER')
EventFrame:RegisterEvent('CHAT_MSG_RAID_LEADER')
EventFrame:RegisterEvent('CHAT_MSG_WHISPER')
EventFrame:RegisterEvent('PLAYER_ENTERING_WORLD')
EventFrame:RegisterEvent('GROUP_ROSTER_UPDATE')
EventFrame:RegisterEvent('COMBAT_LOG_EVENT_UNFILTERED')
EventFrame:RegisterEvent('LOOT_OPENED')
EventFrame:RegisterEvent('PLAYER_LOGOUT')
BohemkaDKP:CheckCompatibility()

if BohemkaDKP.isElvUI then
    BohemkaDKP.REQUIRED_ADDONS["ElvUI"] = false
end

BohemkaDKP.EventFrame = EventFrame;


EventFrame:SetScript('OnEvent', function(self, event, ...)
    if self[event] then
        self[event](self, ...)
    end
end)

function EventFrame:ADDON_LOADED(name)
    local requiredAddon = BohemkaDKP.REQUIRED_ADDONS[name]
    if requiredAddon ~= nil then
        BohemkaDKP:Debug('Required addon', name, 'loaded')
        BohemkaDKP.REQUIRED_ADDONS[name] = true
    end
    local requiredAddonsLoaded = true
    for _, v in pairs (BohemkaDKP.REQUIRED_ADDONS) do
        if not v then
            requiredAddonsLoaded = false
        end
    end
    if requiredAddonsLoaded then
        self:UnregisterEvent('ADDON_LOADED')
        self.ADDON_LOADED = nil
        BohemkaDKP:Debug('All required addons loaded. Initializing...')
        local success = C_ChatInfo.RegisterAddonMessagePrefix(AddonName)
        if success then
            BohemkaDKP:OnLoad()
        else
            BohemkaDKP:Print("Failed to register messaging event!")
        end
    end
end

BohemkaDKP.lastOnlineMembers = 0
function EventFrame:GUILD_ROSTER_UPDATE(...)
    if not GuildFrame:IsShown() then
        GuildStatus_UpdateHook()
    end
    local _, onlineMembers, _ = GetNumGuildMembers();
    if BohemkaDKP.lastOnlineMembers < onlineMembers then
        BohemkaDKP:ShareProfessions()
        BohemkaDKP:ShareTalents()
    end
    BohemkaDKP.lastOnlineMembers = onlineMembers

    if not BohemkaDKP:CanWipeData() then
        BohemkaDKPInterfaceOptionsPanelWipe:Disable()
    else
        BohemkaDKPInterfaceOptionsPanelWipe:Enable()
    end
    if not self.firstLoad then
        BohemkaDKP:SaveCharacterInfo()
    end

end


function EventFrame:GET_ITEM_INFO_RECEIVED(itemId, success)
    if BohemkaDKP.waitForItemInfo and success and itemId == BohemkaDKP.currentItem.id then
        BohemkaDKP.waitForItemInfo = false
        local itemName, _, itemRarity, _, _, _, _, _, _, itemTexture, _ = GetItemInfo(itemId)
        BohemkaDKP:LoadAuctionData(itemId,  BohemkaDKP.currentItem.quantity,  BohemkaDKP.currentItem.price, itemName, itemRarity, itemTexture)
    end
end

function EventFrame:CHAT_MSG_SKILL()
    BohemkaDKP:ShareProfessions()
end
local hookedFrames = {}

function EventFrame:LOOT_OPENED()
    if BohemkaDKP.isElvUI then
        for i=1, GetNumLootItems() do
            local frame = _G["ElvLootSlot"..i]
            if frame and not hookedFrames[frame] then
                hookedFrames[frame] = true
                BohemkaDKP:HookLootItemFrameElvUI(frame, i)
            end
        end
    end

end

BohemkaDKP.events = {
    [BohemkaDKP.EVENT.START_AUCTION] = BohemkaDKP.OnStartAuction,
    [BohemkaDKP.EVENT.BID] = BohemkaDKP.OnBid,
    [BohemkaDKP.EVENT.BID_REQUEST] = BohemkaDKP.OnBidRequest,
    [BohemkaDKP.EVENT.BID_COOLDOWN_END] = BohemkaDKP.OnBidCooldownEnd,
    [BohemkaDKP.EVENT.END_AUCTION] = BohemkaDKP.OnEndAuction,
    [BohemkaDKP.EVENT.END_AUCTION_COUNTDOWN] = BohemkaDKP.OnEndAuctionCountdown,
    [BohemkaDKP.EVENT.END_AUCTION_COUNTDOWN_CANCEL] = BohemkaDKP.OnEndAuctionCountdownCancel,
    [BohemkaDKP.EVENT.PROFESSION_INFO] = BohemkaDKP.OnProfessionInfo,
    [BohemkaDKP.EVENT.TALENTS_INFO] = BohemkaDKP.OnTalentsInfo,
    [BohemkaDKP.EVENT.INVALIDATE_HIGHEST_BID] = BohemkaDKP.OnInvalidateHighestBid,
    [BohemkaDKP.EVENT.AUCTION_JOIN] = BohemkaDKP.OnAuctionJoin,
    [BohemkaDKP.EVENT.AUCTION_JOIN_RESPONSE] = BohemkaDKP.OnAuctionJoinResponse,
    [BohemkaDKP.EVENT.PROFESSION_INFO_REQUEST] = BohemkaDKP.OnProfessionInfoRequest,
    [BohemkaDKP.EVENT.TALENTS_INFO_REQUEST] = BohemkaDKP.OnTalentsInfoRequest,
    [BohemkaDKP.EVENT.PASS_REQUEST] = BohemkaDKP.OnPassRequest,
    [BohemkaDKP.EVENT.LOG] = BohemkaDKP.OnLog,
    [BohemkaDKP.EVENT.SYNC_LOG] = BohemkaDKP.OnSyncLog,
    [BohemkaDKP.EVENT.WIPE_DATA] = BohemkaDKP.OnWipeData,
    [BohemkaDKP.EVENT.WIPE_DATA_ALL] = BohemkaDKP.OnWipeDataAll,
    [BohemkaDKP.EVENT.PAYLOAD_START] = BohemkaDKP.OnPayloadStart,
    [BohemkaDKP.EVENT.PAYLOAD_START_CONFIRM] = BohemkaDKP.OnPayloadStartConfirm,
    [BohemkaDKP.EVENT.ONLINE_CHECK] = BohemkaDKP.OnOnlineCheck,
    [BohemkaDKP.EVENT.ONLINE_CHECK_RESPONSE] = BohemkaDKP.OnOnlineCheckResponse,
}

function EventFrame:CHAT_MSG_ADDON(prefix, message, _, sender)
    if prefix == AddonName then
        if message:sub(1, 1) == BohemkaDKP.COMPRESSED_SEPARATOR then
            local id, order, msg = strsplit(BohemkaDKP.EVENT_SEPARATOR, message:sub(2), 3)
            id = tonumber(id)
            local chunks = BohemkaDKP.chunks[id]
            chunks.data[tonumber(order)] = msg
            chunks.received = chunks.received + 1
            BohemkaDKP:Debug("Saved chunk", order, id, chunks.received.."/"..chunks.size)
            if chunks.size == chunks.received then
                BohemkaDKP:Debug("Processing chunks", id)
                local payload = table.concat(chunks.data)

                BohemkaDKP:Debug("Decoding chunks", id)
                local decoded = LibDeflate:DecodeForWoWAddonChannel(payload)
                if not decoded then
                    BohemkaDKP:Debug("Decoding failed", id)
                    return
                end
                BohemkaDKP:Debug("Decompressing chunks", id)
                local decompressed = LibDeflate:DecompressDeflate(decoded)
                if not decompressed then
                    BohemkaDKP:Debug("Decompression failed", id)
                    return
                end
                BohemkaDKP:Debug("Deserializing chunks", id)
                local success, data = LibSerialize:Deserialize(decompressed)
                if not success then
                    BohemkaDKP:Debug("Deserializing failed", id)
                    return
                end
                data = {strsplit("\n", data)}
                for _, itemStr in ipairs(data) do
                    BohemkaDKP:ProcessEvent(itemStr, _, sender)
                end
                BohemkaDKP.chunks[id] = nil
            end
            return
        end
        if not string.find(sender, "-") then
            sender = sender.."-"..GetRealmName()
        end
        BohemkaDKP:ProcessEvent(message, _, sender)
    end
end

function BohemkaDKP:ProcessEvent(message, _, sender)
    local data = { strsplit(BohemkaDKP.EVENT_SEPARATOR, message) }
    table.insert(data, sender)
    local event = table.remove(data,1)
    if BohemkaDKP.events[event] then
        BohemkaDKP:Debug("Received event", event, "| args:", unpack(data))
        BohemkaDKP.events[event](BohemkaDKP, unpack(data))
    end
end

function EventFrame:PLAYER_ENTERING_WORLD(isLogin, isReload)
    if not isLogin and not isReload then
        return
    end
    GuildRoster()
    BohemkaDKP.firstLoad = true
    if IsInGuild() then
        BohemkaDKP:LoadDataWhenReady()
        BohemkaDKP:ShareProfessions()
        BohemkaDKP:JoinExistingAuction()
        BohemkaDKP:ShareTalents()
    end
end

function EventFrame:COMBAT_LOG_EVENT_UNFILTERED()
    local _, eventType, _, _, _, _, _, _, destName, _, _, recapID, _ = CombatLogGetCurrentEventInfo()
    if eventType == "UNIT_DIED" or eventType == "UNIT_DESTROYED" or eventType == "UNIT_DISSIPATES" then
        if not IsInRaid() or not UnitIsGroupLeader("player") then
            return
        end
        recapLink = GetDeathRecapLink(recapID)
        if BohemkaDKPConfig.bossRewards[destName] then
            BohemkaDKP:AwardDKPRaid(BohemkaDKPConfig.bossRewards[destName], "killing of "..destName)
        end
    end
end


function EventFrame:GROUP_ROSTER_UPDATE()
    if not IsInRaid() then
        ButtonAwardRaidDKP:Hide()
    else
        ButtonAwardRaidDKP:Show()
    end
end


function EventFrame:PLAYER_LOGOUT()
    BohemkaDKPConfig.lastTimeOnline = GetServerTime()
end


function EventFrame:CHAT_MSG_GUILD(...)
    BohemkaDKP:ChatBid(...)
end

function EventFrame:CHAT_MSG_RAID(...)
    BohemkaDKP:ChatBid(...)
end

function EventFrame:CHAT_MSG_RAID_LEADER(...)
    BohemkaDKP:ChatBid(...)
end

function EventFrame:CHAT_MSG_PARTY(...)
    if IsInRaid() then
        return
    end
    BohemkaDKP:ChatBid(...)
end

function EventFrame:CHAT_MSG_PARTY_LEADER(...)
    if IsInRaid() then
        return
    end
    BohemkaDKP:ChatBid(...)
end

